<?php

require_once("class.rest.php");

class API extends REST {

    public function __construct() {
        parent::__construct();
        $this->dbConnect();
    }

    public function dbConnect() {
        $link = mysqli_connect("localhost", "root", "csskti$$1154", "mylea_beta") or die("Error " . mysqli_error($link));
//        mysqli_connect("localhost", "root", "");
//        mysqli_select_db("mylea_beta");
    }

    public function processApi() {
        $func = strtolower(trim(str_replace("/", "", $_REQUEST['action'])));
        if ((int) method_exists($this, $func) > 0)
            $this->$func();
        else
            $this->response('', 404);
    }

    private function login() {


        if ($this->get_request_method() != "GET") {
            $this->response($this->json(array('status' => 'false', 'message' => 'method not allowed.')), 405);
        }

        if (isset($this->_request['userid']) && isset($this->_request['password']) && !empty($this->_request['userid']) && !empty($this->_request['password'])) {

            $userid = $this->_request['userid'];
            $password = $this->_request['password'];

            $link = mysqli_connect("localhost", "root", "csskti$$1154", "mylea_beta") or die("Error " . mysqli_error($link));
            $key = '1234567890123456';
            $sql = "SELECT * FROM `people` WHERE `userid`='" . $userid . "' AND `password`='" . $this->encrypt($password, $key) . "'";
            $result = mysqli_query($link, $sql);

            $num_rows = mysqli_num_rows($result);

            if ($num_rows > 0) {
                $res = array('status' => 'true', 'message' => 'user successfully logged in.');
                $this->response($this->json($res), 200);
            }
            $res = array('status' => 'false', 'message' => 'wrong userid or password.');
            $this->response($this->json($res), 404);
        }

        $error = array('status' => 'false', 'message' => 'Invalid userid or password');
        $this->response($this->json($error), 200);
    }

    private function json($data) {
        if (is_array($data)) {
            return json_encode($data);
        }
    }

    private function encrypt($data, $key) {
        return base64_encode(
                mcrypt_encrypt(
                        MCRYPT_RIJNDAEL_128, $key, $data, MCRYPT_MODE_CBC, "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
                )
        );
    }

    private function addActivity() {
        if ($this->get_request_method() != "GET") {
            $this->response($this->json(array('status' => 'false', 'message' => 'method not allowed.')), 405);
        }

        if (isset($this->_request['datasourceid']) && isset($this->_request['activityid']) && isset($this->_request['studentid']) && !empty($this->_request['datasourceid']) && !empty($this->_request['activityid']) && !empty($this->_request['studentid'])) {

            $stdid = $this->_request['studentid'];
            $datasource = $this->_request['datasourceid'];
            $activity = $this->_request['activityid'];
            $error = 0;

            $link = mysqli_connect("localhost", "root", "csskti$$1154", "mylea_beta") or die("Error " . mysqli_error($link));

            $qry1 = "SELECT * FROM activities WHERE id = '" . $activity . "' AND datasource = '" . $datasource . "'";
            $res1 = mysqli_query($link, $qry1);
            $row1 = mysqli_fetch_assoc($res1);

            $qry2 = "SELECT * FROM extlink WHERE datasourceid ='" . $datasource . "' AND extid = '" . $_GET['studentid'] . "'";
            $res2 = mysqli_query($link, $qry2);
            $row2 = mysqli_fetch_assoc($res2);

            // to check if group is associated to student 
            $studentid = $row2['internalstdid'];
            $qry3 = "SELECT * FROM group_has_students WHERE studentid = '" . $studentid . "'";
            $res3 = mysqli_query($link, $qry3);
            $row3 = mysqli_fetch_assoc($res3);
            if ($row3) {
                $groupid = $row3['groupid'];
            } else {
//                deliver_response(400, "No Group associated to Student");
                $error = array('status' => 'false', 'message' => 'No Group associated to Student');
                $this->response($this->json($error), 400);
                $error = 1;
                exit();
            }
            // to check if no competency associated to activity
            $qry4 = "SELECT * FROM activities_has_competencies WHERE activityid = '" . $activity . "'";
            $res4 = mysqli_query($link, $qry4);
            if ($res4->num_rows == '') {
//                deliver_response(400, "No Competency associated to Activity");
                $error = array('status' => 'false', 'message' => 'No Competency associated to Activity');
                $this->response($this->json($error), 400);
                $error = 1;
//                exit();
            }

            // to verify record duplication 
            if ($error == 0) {
                $qry5 = "SELECT * FROM rawdata WHERE studid = '" . $stdid . "'";
                $res5 = mysqli_query($link, $qry5);
                $num_row5 = mysqli_num_rows($res5);

                if ($num_row5 == 0) {
                    $qry6 = "INSERT INTO rawdata (studid,datasourceid, activityid) VALUE ( '" . $stdid . "','" . $datasource . "', '" . $activity . "' )";
                    $res6 = mysqli_query($link, $qry6);
                    $res = array('status' => 'true', 'message' => 'Activity logged successfully');
                    $this->response($this->json($res), 200);
                } else {
//                    deliver_response(400, "Record already exit");
                    $error = array('status' => 'false', 'message' => 'Record already exit');
                    $this->response($this->json($error), 400);
                }
            }
        }

        $error = array('status' => 'false', 'message' => 'Invalid userid or password');
        $this->response($this->json($error), 200);
    }

}

$api = new API;
$api->processApi();
?>