<?php
require_once '../../config.php';
$qry = "SELECT * FROM subjects WHERE schoolid=" . $_SESSION['schoolid'];
$res = $link->query($qry);
$qry1 = "SELECT * FROM datasource WHERE schoolid=" . $_SESSION['schoolid'];
$res1 = $link->query($qry1);
$success = true;
$message = '';
$errors = array();

//function to call API and send data

function OlmCompetencyOperationCall($data, $url) {
    $postvars = '';
    foreach ($data as $key => $value) {
        $postvars .= $key . "=" . $value . "&";
    }
    $postvars = rtrim($postvars, "&");
//    echo $url . $postvars;

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_POST, 1);                //0 for a get request
    curl_setopt($ch, CURLOPT_POSTFIELDS, $postvars);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 3);
    curl_setopt($ch, CURLOPT_TIMEOUT, 20);
    $response = curl_exec($ch);
    "curl response is:" . $response;
    echo $response;
    curl_close($ch);
}

if (isset($_POST['submit'])) {

    if (isset($_POST['name']) && $_POST['name'] != '') {
        $name = $_POST['name'];
    } else {
        $errors['name'] = 'Enter Activity Name';
        $success = false;
    }
    if (isset($_POST['position']) && $_POST['position'] != '') {
        $position = $_POST['position'];
    } else {
        $errors['position'] = 'Enter position';
        $success = false;
    }
    if (isset($_POST['influence']) && $_POST['influence'] != '') {
        $influence = $_POST['influence'];
    } else {
        $errors['influence'] = 'Enter influence';
        $success = false;
    }

    if (isset($_POST['threshold']) && $_POST['threshold'] != '') {
        $threshold = $_POST['threshold'];
    }
    else {
        $errors['threshold'] = 'Enter threshold';
        $success = false;
    }
    if (isset($_POST['datasource']) && $_POST['datasource'] != '') {
        $datasource = $_POST['datasource'];
    } else {
        $errors['datasource'] = 'Select At least one ds';
    }
    if (isset($_POST['subject']) && $_POST['subject'] != '') {
        $subject = $_POST['subject'];
        if (isset($_POST['competency']) && $_POST['competency'] != '') {
            $competencies = $_POST['competency'];
//            if (!empty($competencies)) {
//                foreach ($_POST['competency'] as $k => $v) {
//                    if (isset($_POST['competencyWeight' . $v]) && $_POST['competencyWeight' . $v] == '') {
//                        $errors['weight'] = "Weight missing for selected competency";
//                        $success = false;
//                    }
//                }
//            }
        } else {
            $errors['competency'] = 'Select At least one competency';
            $success = false;
        }
    } else {
        $errors['subject'] = 'Select Subject';
        $success = false;
    }


    if ($success) {
        $qry = "SELECT name FROM activities WHERE name='" . $name . "' AND schoolid = '" . $_SESSION['schoolid'] . "'";
        mysqli_query($link, "SET NAMES UTF8");
        $res1 = $link->query($qry);
        if ($res1->num_rows == 0) {

            $qry = "INSERT INTO activities (name,schoolid,subject,position,activityinfluence,datasource,threshold) VALUES('" . $name . "'," . $_SESSION['schoolid'] . "," . $_POST['subject'] . " ," . $_POST['position'] . "," . $_POST['influence'] . "," . $_POST['datasource'] . "," . $_POST['threshold'] . ")";
            mysqli_query($link, "SET NAMES UTF8");
            $res2 = $link->query($qry);
            $lastInsertId = mysqli_insert_id($link);
            $qry3 = "INSERT INTO activities_has_subjects (activityid, subjectid) VALUES ('" . $lastInsertId . "' , '" . $_POST['subject'] . "')";
            $res3 = $link->query($qry3);

            // array to send values to olm to add activity
            $url = "http://eeevle.bham.ac.uk/leas-olm/api/masterapi?";

            $data = array('sharedsecret' => 'l753Ea{sB[]o}x*',
                'leasid' => $_SESSION['userid'],
                'method' => 'updateactivity',
                'activityid' => $lastInsertId,
                'activityname' => $name,
                'position' => 1,
                'activityinfluence' => 0.5,
                'subjectid' => $_POST['subject'],
            );
            echo OlmCompetencyOperationCall($data, $url);

            // end add competency to activity

            if (isset($_POST['competency'])) {
                $values = array();
                foreach ($_POST['competency'] as $ke => $va) {
                    $values[] = "(" . $lastInsertId . "," . $va . ")";
                }
                $query = "INSERT INTO activities_has_competencies (activityid,competenceid) VALUES " . implode(',', $values);
                $res3 = $link->query($query);

                //add competency to activity
                $qry = "SELECT * FROM activities_has_competencies WHERE activityid= '" . $lastInsertId . "'";
                $res4 = mysqli_query($link, $qry);
                $num_row1 = mysqli_num_rows($res4);
                if ($num_row1 > 0) {
                    while ($row4 = mysqli_fetch_assoc($res4)) {
                        $data1 = array('sharedsecret' => 'l753Ea{sB[]o}x*',
                            'leasid' => $_SESSION['userid'],
                            'method' => 'addcompetencytoactivity',
                            'competencyid' => $row4['competenceid'],
                            'activityid' => $lastInsertId
                        );
                        echo OlmCompetencyOperationCall($data1, $url);
                    }
                } // end add competency to activity


                if ($res3) {
                    $message = "Activity added successfully.";
                    unset($_POST['name']);
                    unset($_POST['subject']);
                    unset($_POST['position']);
                    unset($_POST['influence']);
                    unset($_POST['threshold']);
                    unset($_POST['datasource']);

                    $success = true;
                }
            }
        } else {
            $errors['duplicate'] = "Activity must be unique.";
            $success = false;
        }
    }
}
?>
<a href="./" class="btn btn-success" style="margin-bottom: 10px">Back</a>
<form action="" method="post">
    <?php
    if (!$success && !empty($errors)) {
        echo '<div class="form-group has-error">';
        foreach ($errors as $key => $value) {
            echo "<p class='has-error help-block'>" . $value . "</p>";
        }
        echo '</div>';
    } else if ($message != '' && $success) {
        echo '<div class="form-group has-success">';

        echo "<p class='has-success help-block'>" . $message . "</p>";

        echo '</div>';
    }
    ?>
    <div class="form-group" width = "10">
        <label for="name">Name</label>
        <input type="name" name="name" class="form-control" id="name" placeholder="" value="<?php echo (isset($_POST['name']) && !$success) ? $_POST['name'] : ''; ?>">
    </div>
    <div class="form-group">
        <label for="positon">Position</label>
        <input type="name" name="position" class="form-control" id="position" placeholder="" value="<?php echo (isset($_POST['position']) && !$success) ? $_POST['position'] : ''; ?>">
    </div>
    <div class="form-group">
        <label for="activityinfluence">Activity Influence</label>
        <input type="name" name="influence" class="form-control" id="influence" placeholder="" value="<?php echo (isset($_POST['activityinfluence']) && !$success) ? $_POST['activityinfluence'] : ''; ?>">
    </div>
    <div class="form-group">
        <label for="activityinfluence">Activity Threshold</label>
        <input type="name" name="threshold" class="form-control" id="threshold" placeholder="" value="<?php echo (isset($_POST['threshold']) && !$success) ? $_POST['threshold'] : ''; ?>">
    </div>



    <!--// to get data source in drop down-->
    <div class="form-group">
        <label for="datasource">DataSource</label>
        <select class="form-control" id="datasource" name="datasource">
        <!--<select class="form-control" id="subject" name="subject" onchange="getcompetencies(this.value)">-->
            <option value="">Select Datasource</option>
            <?php
            if ($res1->field_count > 0) {

                while ($row1 = mysqli_fetch_assoc($res1)) {
                    $selected = '';
                    if (isset($_POST['datasource']) && $_POST['datasource'] == $row1['id'] && !$success) {
                        ?>
                                                <!--                        <script>
                                                                            $.ajax({
                                                                                url: 'getcompetencies.php?id=' +<?php // echo $row['id'];    ?>,
                        <?php // if (isset($_POST['competency'])) {   ?>
                                                                                    data: <?php // echo json_encode($_POST);   ?>,
                                                                                    type: 'POST',
                        <?php // }    ?>
                                                                                success: function (data) {

                                                                                    $("#competency").html('');
                                                                                    $("#competency").html(data);
                                                                                }
                                                                            });
                                                                        </script>-->
                        <?php
                        $selected = 'selected';
                    }
                    echo "<option value='" . $row1['id'] . "' " . $selected . ">" . $row1['name'] . "</option>";
                }
            }
            ?>

        </select>
    </div>

    <!--// end data source-->

    <div class="form-group">
        <label for="subject">Subject</label>
<!--        <select class="form-control" id="subject" name="subject">-->
        <select class="form-control" id="subject" name="subject" onchange="getcompetencies(this.value)">
            <option value="">Select Subject</option>
            <?php
            if ($res->field_count > 0) {
                while ($row = mysqli_fetch_assoc($res)) {
                    echo "<pre>";
                    print_r($row);
                    echo "</pre>";
                    $selected = '';
                    if (isset($_POST['subject']) && $_POST['subject'] == $row['id'] && !$success) {
                        ?>
                        <script>
                            $.ajax({
                                url: 'getcompetencies.php?id=' +<?php echo $row['id']; ?>,
            <?php if (isset($_POST['competency'])) { ?>
                                    data: <?php echo json_encode($_POST); ?>,
                                    type: 'POST',
            <?php } ?>
                                success: function (data) {

                                    $("#competency").html('');
                                    $("#competency").html(data);
                                }
                            });
                        </script>
                        <?php
                        $selected = 'selected';
                    }
                    echo "<option value='" . $row['id'] . "' " . $selected . ">" . $row['name'] . "</option>";
                }
            }
            ?>

        </select>
    </div>

    <div id="competency">

    </div>
    <input type="submit" name="submit" class="btn btn-default" value="Submit"/>
</form>

