<?php

session_start();

if (!isset($_SESSION['uName'])) {
    header('Location:../../');
}
// DataTables PHP library
include( "../../php/DataTables.php" );

// Alias Editor classes so they are easy to use
use DataTables\Editor,
    DataTables\Editor\Field,
    DataTables\Editor\Format,
    DataTables\Editor\Join,
    DataTables\Editor\Upload,
    DataTables\Editor\Validate;

/*
 * Example PHP implementation used for the join.html example
 */
Editor::inst($db, 'extlink')
        ->field(
                Field::inst('extlink.id'),
                Field::inst('extlink.internalstdid'),
                Field::inst('extlink.extid'),
                Field::inst('extlink.teacherid'),
                Field::inst('extlink.extteacher'),
                Field::inst('extlink.datasourceid'),
                Field::inst('extlink.schoolid')
                ->setValue($_SESSION['schoolid'])
                
        )
        ->where('extlink.schoolid', $_SESSION['schoolid'])
        ->process($_POST)
        ->json();
