/*!
 DataTables Editor v1.4.2
 
 Â©2012-2014 SpryMedia Ltd, all rights reserved.
 License: editor.datatables.net/license
 */
(function(r, q, j) {
    var x = function(d, u) {
        function v(a) {
            a = a.context[0];
            return a.oInit.editor || a._editor
        }
        function y(a, b, c, d) {
            b || (b = {});
            b.buttons === j && (b.buttons = "_basic");
            b.title === j && (b.title = a.i18n[c].title);
            b.message === j && ("remove" === c ? (a = a.i18n[c].confirm, b.message = 1 !== d ? a._.replace(/%d/, d) : a["1"]) : b.message = "");
            return b
        }
        if (!u || !u.versionCheck || !u.versionCheck("1.10"))
            throw"Editor requires DataTables 1.10 or newer";
        var e = function(a) {
            !this instanceof e && alert("DataTables Editor must be initialised as a 'new' instance'");
            this._constructor(a)
        };
        u.Editor = e;
        d.fn.DataTable.Editor = e;
        var t = function(a, b) {
            b === j && (b = q);
            return d('*[data-dte-e="' + a + '"]', b)
        }, x = 0;
        e.Field = function(a, b, c) {
            var i = this, a = d.extend(!0, {}, e.Field.defaults, a);
            this.s = d.extend({}, e.Field.settings, {type: e.fieldTypes[a.type], name: a.name, classes: b, host: c, opts: a});
            a.id || (a.id = "DTE_Field_" + a.name);
            a.dataProp && (a.data = a.dataProp);
            "" === a.data && (a.data = a.name);
            var g = u.ext.oApi;
            this.valFromData = function(b) {
                return g._fnGetObjectDataFn(a.data)(b, "editor")
            };
            this.valToData =
                    g._fnSetObjectDataFn(a.data);
            b = d('<div class="' + b.wrapper + " " + b.typePrefix + a.type + " " + b.namePrefix + a.name + " " + a.className + '"><label data-dte-e="label" class="' + b.label + '" for="' + a.id + '">' + a.label + '<div data-dte-e="msg-label" class="' + b["msg-label"] + '">' + a.labelInfo + '</div></label><div data-dte-e="input" class="' + b.input + '"><div data-dte-e="msg-error" class="' + b["msg-error"] + '"></div><div data-dte-e="msg-message" class="' + b["msg-message"] + '"></div><div data-dte-e="msg-info" class="' + b["msg-info"] +
                    '">' + a.fieldInfo + "</div></div></div>");
            c = this._typeFn("create", a);
            null !== c ? t("input", b).prepend(c) : b.css("display", "none");
            this.dom = d.extend(!0, {}, e.Field.models.dom, {container: b, label: t("label", b), fieldInfo: t("msg-info", b), labelInfo: t("msg-label", b), fieldError: t("msg-error", b), fieldMessage: t("msg-message", b)});
            d.each(this.s.type, function(a, b) {
                typeof b === "function" && i[a] === j && (i[a] = function() {
                    var b = Array.prototype.slice.call(arguments);
                    b.unshift(a);
                    b = i._typeFn.apply(i, b);
                    return b === j ? i : b
                })
            })
        };
        e.Field.prototype =
                {dataSrc: function() {
                        return this.s.opts.data
                    }, valFromData: null, valToData: null, destroy: function() {
                        this.dom.container.remove();
                        this._typeFn("destroy");
                        return this
                    }, def: function(a) {
                        var b = this.s.opts;
                        if (a === j)
                            return a = b["default"] !== j ? b["default"] : b.def, d.isFunction(a) ? a() : a;
                        b.def = a;
                        return this
                    }, disable: function() {
                        this._typeFn("disable");
                        return this
                    }, displayed: function() {
                        var a = this.dom.container;
                        return a.parents("body").length && "none" != a.css("display") ? !0 : !1
                    }, enable: function() {
                        this._typeFn("enable");
                        return this
                    },
                    error: function(a, b) {
                        var c = this.s.classes;
                        a ? this.dom.container.addClass(c.error) : this.dom.container.removeClass(c.error);
                        return this._msg(this.dom.fieldError, a, b)
                    }, inError: function() {
                        return this.dom.container.hasClass(this.s.classes.error)
                    }, input: function() {
                        return this.s.type.input ? this._typeFn("input") : d("input, select, textarea", this.dom.container)
                    }, focus: function() {
                        this.s.type.focus ? this._typeFn("focus") : d("input, select, textarea", this.dom.container).focus();
                        return this
                    }, get: function() {
                        var a = this._typeFn("get");
                        return a !== j ? a : this.def()
                    }, hide: function(a) {
                        var b = this.dom.container;
                        a === j && (a = !0);
                        this.s.host.display() && a ? b.slideUp() : b.css("display", "none");
                        return this
                    }, label: function(a) {
                        var b = this.dom.label;
                        if (a === j)
                            return b.html();
                        b.html(a);
                        return this
                    }, message: function(a, b) {
                        return this._msg(this.dom.fieldMessage, a, b)
                    }, name: function() {
                        return this.s.opts.name
                    }, node: function() {
                        return this.dom.container[0]
                    }, set: function(a) {
                        return this._typeFn("set", a)
                    }, show: function(a) {
                        var b = this.dom.container;
                        a === j && (a = !0);
                        this.s.host.display() &&
                                a ? b.slideDown() : b.css("display", "block");
                        return this
                    }, val: function(a) {
                        return a === j ? this.get() : this.set(a)
                    }, _errorNode: function() {
                        return this.dom.fieldError
                    }, _msg: function(a, b, c) {
                        a.parent().is(":visible") ? (a.html(b), b ? a.slideDown(c) : a.slideUp(c)) : (a.html(b || "").css("display", b ? "block" : "none"), c && c());
                        return this
                    }, _typeFn: function(a) {
                        var b = Array.prototype.slice.call(arguments);
                        b.shift();
                        b.unshift(this.s.opts);
                        var c = this.s.type[a];
                        if (c)
                            return c.apply(this.s.host, b)
                    }};
        e.Field.models = {};
        e.Field.defaults =
                {className: "", data: "", def: "", fieldInfo: "", id: "", label: "", labelInfo: "", name: null, type: "text"};
        e.Field.models.settings = {type: null, name: null, classes: null, opts: null, host: null};
        e.Field.models.dom = {container: null, label: null, labelInfo: null, fieldInfo: null, fieldError: null, fieldMessage: null};
        e.models = {};
        e.models.displayController = {init: function() {
            }, open: function() {
            }, close: function() {
            }};
        e.models.fieldType = {create: function() {
            }, get: function() {
            }, set: function() {
            }, enable: function() {
            }, disable: function() {
            }};
        e.models.settings =
                {ajaxUrl: null, ajax: null, dataSource: null, domTable: null, opts: null, displayController: null, fields: {}, order: [], id: -1, displayed: !1, processing: !1, modifier: null, action: null, idSrc: null};
        e.models.button = {label: null, fn: null, className: null};
        e.models.formOptions = {submitOnReturn: !0, submitOnBlur: !1, blurOnBackground: !0, closeOnComplete: !0, onEsc: "close", focus: 0, buttons: !0, title: !0, message: !0};
        e.display = {};
        var o = jQuery, h;
        e.display.lightbox = o.extend(!0, {}, e.models.displayController, {init: function() {
                h._init();
                return h
            },
            open: function(a, b, c) {
                if (h._shown)
                    c && c();
                else {
                    h._dte = a;
                    a = h._dom.content;
                    a.children().detach();
                    a.append(b).append(h._dom.close);
                    h._shown = true;
                    h._show(c)
                }
            }, close: function(a, b) {
                if (h._shown) {
                    h._dte = a;
                    h._hide(b);
                    h._shown = false
                } else
                    b && b()
            }, _init: function() {
                if (!h._ready) {
                    var a = h._dom;
                    a.content = o("div.DTED_Lightbox_Content", h._dom.wrapper);
                    a.wrapper.css("opacity", 0);
                    a.background.css("opacity", 0)
                }
            }, _show: function(a) {
                var b = h._dom;
                r.orientation !== j && o("body").addClass("DTED_Lightbox_Mobile");
                b.content.css("height",
                        "auto");
                b.wrapper.css({top: -h.conf.offsetAni});
                o("body").append(h._dom.background).append(h._dom.wrapper);
                h._heightCalc();
                b.wrapper.animate({opacity: 1, top: 0}, a);
                b.background.animate({opacity: 1});
                b.close.bind("click.DTED_Lightbox", function() {
                    h._dte.close()
                });
                b.background.bind("click.DTED_Lightbox", function() {
                    h._dte.blur()
                });
                o("div.DTED_Lightbox_Content_Wrapper", b.wrapper).bind("click.DTED_Lightbox", function(a) {
                    o(a.target).hasClass("DTED_Lightbox_Content_Wrapper") && h._dte.blur()
                });
                o(r).bind("resize.DTED_Lightbox",
                        function() {
                            h._heightCalc()
                        });
                h._scrollTop = o("body").scrollTop();
                if (r.orientation !== j) {
                    a = o("body").children().not(b.background).not(b.wrapper);
                    o("body").append('<div class="DTED_Lightbox_Shown"/>');
                    o("div.DTED_Lightbox_Shown").append(a)
                }
            }, _heightCalc: function() {
                var a = h._dom, b = o(r).height() - h.conf.windowPadding * 2 - o("div.DTE_Header", a.wrapper).outerHeight() - o("div.DTE_Footer", a.wrapper).outerHeight();
                o("div.DTE_Body_Content", a.wrapper).css("maxHeight", b)
            }, _hide: function(a) {
                var b = h._dom;
                a || (a = function() {
                });
                if (r.orientation !== j) {
                    var c = o("div.DTED_Lightbox_Shown");
                    c.children().appendTo("body");
                    c.remove()
                }
                o("body").removeClass("DTED_Lightbox_Mobile").scrollTop(h._scrollTop);
                b.wrapper.animate({opacity: 0, top: h.conf.offsetAni}, function() {
                    o(this).detach();
                    a()
                });
                b.background.animate({opacity: 0}, function() {
                    o(this).detach()
                });
                b.close.unbind("click.DTED_Lightbox");
                b.background.unbind("click.DTED_Lightbox");
                o("div.DTED_Lightbox_Content_Wrapper", b.wrapper).unbind("click.DTED_Lightbox");
                o(r).unbind("resize.DTED_Lightbox")
            },
            _dte: null, _ready: !1, _shown: !1, _dom: {wrapper: o('<div class="DTED DTED_Lightbox_Wrapper"><div class="DTED_Lightbox_Container"><div class="DTED_Lightbox_Content_Wrapper"><div class="DTED_Lightbox_Content"></div></div></div></div>'), background: o('<div class="DTED_Lightbox_Background"><div/></div>'), close: o('<div class="DTED_Lightbox_Close"></div>'), content: null}});
        h = e.display.lightbox;
        h.conf = {offsetAni: 25, windowPadding: 25};
        var k = jQuery, f;
        e.display.envelope = k.extend(!0, {}, e.models.displayController, {init: function(a) {
                f._dte =
                        a;
                f._init();
                return f
            }, open: function(a, b, c) {
                f._dte = a;
                k(f._dom.content).children().detach();
                f._dom.content.appendChild(b);
                f._dom.content.appendChild(f._dom.close);
                f._show(c)
            }, close: function(a, b) {
                f._dte = a;
                f._hide(b)
            }, _init: function() {
                if (!f._ready) {
                    f._dom.content = k("div.DTED_Envelope_Container", f._dom.wrapper)[0];
                    q.body.appendChild(f._dom.background);
                    q.body.appendChild(f._dom.wrapper);
                    f._dom.background.style.visbility = "hidden";
                    f._dom.background.style.display = "block";
                    f._cssBackgroundOpacity = k(f._dom.background).css("opacity");
                    f._dom.background.style.display = "none";
                    f._dom.background.style.visbility = "visible"
                }
            }, _show: function(a) {
                a || (a = function() {
                });
                f._dom.content.style.height = "auto";
                var b = f._dom.wrapper.style;
                b.opacity = 0;
                b.display = "block";
                var c = f._findAttachRow(), d = f._heightCalc(), g = c.offsetWidth;
                b.display = "none";
                b.opacity = 1;
                f._dom.wrapper.style.width = g + "px";
                f._dom.wrapper.style.marginLeft = -(g / 2) + "px";
                f._dom.wrapper.style.top = k(c).offset().top + c.offsetHeight + "px";
                f._dom.content.style.top = -1 * d - 20 + "px";
                f._dom.background.style.opacity =
                        0;
                f._dom.background.style.display = "block";
                k(f._dom.background).animate({opacity: f._cssBackgroundOpacity}, "normal");
                k(f._dom.wrapper).fadeIn();
                f.conf.windowScroll ? k("html,body").animate({scrollTop: k(c).offset().top + c.offsetHeight - f.conf.windowPadding}, function() {
                    k(f._dom.content).animate({top: 0}, 600, a)
                }) : k(f._dom.content).animate({top: 0}, 600, a);
                k(f._dom.close).bind("click.DTED_Envelope", function() {
                    f._dte.close()
                });
                k(f._dom.background).bind("click.DTED_Envelope", function() {
                    f._dte.blur()
                });
                k("div.DTED_Lightbox_Content_Wrapper",
                        f._dom.wrapper).bind("click.DTED_Envelope", function(a) {
                    k(a.target).hasClass("DTED_Envelope_Content_Wrapper") && f._dte.blur()
                });
                k(r).bind("resize.DTED_Envelope", function() {
                    f._heightCalc()
                })
            }, _heightCalc: function() {
                f.conf.heightCalc ? f.conf.heightCalc(f._dom.wrapper) : k(f._dom.content).children().height();
                var a = k(r).height() - f.conf.windowPadding * 2 - k("div.DTE_Header", f._dom.wrapper).outerHeight() - k("div.DTE_Footer", f._dom.wrapper).outerHeight();
                k("div.DTE_Body_Content", f._dom.wrapper).css("maxHeight", a);
                return k(f._dte.dom.wrapper).outerHeight()
            }, _hide: function(a) {
                a || (a = function() {
                });
                k(f._dom.content).animate({top: -(f._dom.content.offsetHeight + 50)}, 600, function() {
                    k([f._dom.wrapper, f._dom.background]).fadeOut("normal", a)
                });
                k(f._dom.close).unbind("click.DTED_Lightbox");
                k(f._dom.background).unbind("click.DTED_Lightbox");
                k("div.DTED_Lightbox_Content_Wrapper", f._dom.wrapper).unbind("click.DTED_Lightbox");
                k(r).unbind("resize.DTED_Lightbox")
            }, _findAttachRow: function() {
                var a = k(f._dte.s.table).DataTable();
                return f.conf.attach === "head" ? a.table().header() : f._dte.s.action === "create" ? a.table().header() : a.row(f._dte.s.modifier).node()
            }, _dte: null, _ready: !1, _cssBackgroundOpacity: 1, _dom: {wrapper: k('<div class="DTED DTED_Envelope_Wrapper"><div class="DTED_Envelope_ShadowLeft"></div><div class="DTED_Envelope_ShadowRight"></div><div class="DTED_Envelope_Container"></div></div>')[0], background: k('<div class="DTED_Envelope_Background"><div/></div>')[0], close: k('<div class="DTED_Envelope_Close">&times;</div>')[0],
                content: null}});
        f = e.display.envelope;
        f.conf = {windowPadding: 50, heightCalc: null, attach: "row", windowScroll: !0};
        e.prototype.add = function(a) {
            if (d.isArray(a))
                for (var b = 0, c = a.length; b < c; b++)
                    this.add(a[b]);
            else {
                b = a.name;
                if (b === j)
                    throw"Error adding field. The field requires a `name` option";
                if (this.s.fields[b])
                    throw"Error adding field '" + b + "'. A field already exists with this name";
                this._dataSource("initField", a);
                this.s.fields[b] = new e.Field(a, this.classes.field, this);
                this.s.order.push(b)
            }
            return this
        };
        e.prototype.blur =
                function() {
                    this._blur();
                    return this
                };
        e.prototype.bubble = function(a, b, c) {
            var i = this, g, e;
            if (this._tidy(function() {
                i.bubble(a, b, c)
            }))
                return this;
            d.isPlainObject(b) && (c = b, b = j);
            c = d.extend({}, this.s.formOptions.bubble, c);
            b ? (d.isArray(b) || (b = [b]), d.isArray(a) || (a = [a]), g = d.map(b, function(a) {
                return i.s.fields[a]
            }), e = d.map(a, function() {
                return i._dataSource("individual", a)
            })) : (d.isArray(a) || (a = [a]), e = d.map(a, function(a) {
                return i._dataSource("individual", a, null, i.s.fields)
            }), g = d.map(e, function(a) {
                return a.field
            }));
            this.s.bubbleNodes = d.map(e, function(a) {
                return a.node
            });
            e = d.map(e, function(a) {
                return a.edit
            }).sort();
            if (e[0] !== e[e.length - 1])
                throw"Editing is limited to a single row only";
            this._edit(e[0], "bubble");
            var f = this._formOptions(c);
            d(r).on("resize." + f, function() {
                i.bubblePosition()
            });
            if (!this._preopen("bubble"))
                return this;
            var l = this.classes.bubble;
            e = d('<div class="' + l.wrapper + '"><div class="' + l.liner + '"><div class="' + l.table + '"><div class="' + l.close + '" /></div></div><div class="' + l.pointer + '" /></div>').appendTo("body");
            l = d('<div class="' + l.bg + '"><div/></div>').appendTo("body");
            this._displayReorder(g);
            var p = e.children().eq(0), h = p.children(), k = h.children();
            p.append(this.dom.formError);
            h.prepend(this.dom.form);
            c.message && p.prepend(this.dom.formInfo);
            c.title && p.prepend(this.dom.header);
            c.buttons && h.append(this.dom.buttons);
            var m = d().add(e).add(l);
            this._closeReg(function() {
                m.animate({opacity: 0}, function() {
                    m.detach();
                    d(r).off("resize." + f);
                    i._clearDynamicInfo()
                })
            });
            l.click(function() {
                i.blur()
            });
            k.click(function() {
                i._close()
            });
            this.bubblePosition();
            m.animate({opacity: 1});
            this._focus(g, c.focus);
            this._postopen("bubble");
            return this
        };
        e.prototype.bubblePosition = function() {
            var a = d("div.DTE_Bubble"), b = d("div.DTE_Bubble_Liner"), c = this.s.bubbleNodes, i = 0, g = 0, e = 0;
            d.each(c, function(a, b) {
                var c = d(b).offset();
                i += c.top;
                g += c.left;
                e += c.left + b.offsetWidth
            });
            var i = i / c.length, g = g / c.length, e = e / c.length, c = i, f = (g + e) / 2, l = b.outerWidth(), p = f - l / 2, l = p + l, j = d(r).width();
            a.css({top: c, left: f});
            l + 15 > j ? b.css("left", 15 > p ? -(p - 15) : -(l - j + 15)) : b.css("left",
                    15 > p ? -(p - 15) : 0);
            return this
        };
        e.prototype.buttons = function(a) {
            var b = this;
            "_basic" === a ? a = [{label: this.i18n[this.s.action].submit, fn: function() {
                        this.submit()
                    }}] : d.isArray(a) || (a = [a]);
            d(this.dom.buttons).empty();
            d.each(a, function(a, i) {
                "string" === typeof i && (i = {label: i, fn: function() {
                        this.submit()
                    }});
                d("<button/>", {"class": b.classes.form.button + (i.className ? " " + i.className : "")}).html(i.label || "").attr("tabindex", 0).on("keyup", function(a) {
                    13 === a.keyCode && i.fn && i.fn.call(b)
                }).on("keypress", function(a) {
                    13 ===
                            a.keyCode && a.preventDefault()
                }).on("mousedown", function(a) {
                    a.preventDefault()
                }).on("click", function(a) {
                    a.preventDefault();
                    i.fn && i.fn.call(b)
                }).appendTo(b.dom.buttons)
            });
            return this
        };
        e.prototype.clear = function(a) {
            var b = this, c = this.s.fields;
            if (a)
                if (d.isArray(a))
                    for (var c = 0, i = a.length; c < i; c++)
                        this.clear(a[c]);
                else
                    c[a].destroy(), delete c[a], a = d.inArray(a, this.s.order), this.s.order.splice(a, 1);
            else
                d.each(c, function(a) {
                    b.clear(a)
                });
            return this
        };
        e.prototype.close = function() {
            this._close(!1);
            return this
        };
        e.prototype.create = function(a, b, c, i) {
            var g = this;
            if (this._tidy(function() {
                g.create(a, b, c, i)
            }))
                return this;
            var e = this.s.fields, f = this._crudArgs(a, b, c, i);
            this.s.action = "create";
            this.s.modifier = null;
            this.dom.form.style.display = "block";
            this._actionClass();
            d.each(e, function(a, b) {
                b.set(b.def())
            });
            this._event("initCreate");
            this._assembleMain();
            this._formOptions(f.opts);
            f.maybeOpen();
            return this
        };
        e.prototype.dependent = function(a, b, c) {
            var i = this, g = this.field(a), e = {type: "POST", dataType: "json"}, c = d.extend({event: "change",
                data: null, preUpdate: null, postUpdate: null}, c), f = function(a) {
                c.preUpdate && c.preUpdate(a);
                d.each({labels: "label", options: "update", values: "val", messages: "message", errors: "error"}, function(b, c) {
                    a[b] && d.each(a[b], function(a, b) {
                        i.field(a)[c](b)
                    })
                });
                d.each(["hide", "show", "enable", "disable"], function(b, c) {
                    if (a[c])
                        i[c](a[c])
                });
                c.postUpdate && c.postUpdate(a)
            };
            g.input().on(c.event, function() {
                var a = {};
                a.row = i._dataSource("get", i.modifier(), i.s.fields);
                a.values = i.val();
                if (c.data) {
                    var p = c.data(a);
                    p && (c.data = p)
                }
                "function" ===
                        typeof b ? (a = b(g.val(), a, f)) && f(a) : (d.isPlainObject(b) ? d.extend(e, b) : e.url = b, d.ajax(d.extend(e, {url: b, data: a, success: f})))
            });
            return this
        };
        e.prototype.disable = function(a) {
            var b = this.s.fields;
            d.isArray(a) || (a = [a]);
            d.each(a, function(a, d) {
                b[d].disable()
            });
            return this
        };
        e.prototype.display = function(a) {
            return a === j ? this.s.displayed : this[a ? "open" : "close"]()
        };
        e.prototype.displayed = function() {
            return d.map(this.s.fields, function(a, b) {
                return a.displayed() ? b : null
            })
        };
        e.prototype.edit = function(a, b, c, d, g) {
            var e = this;
            if (this._tidy(function() {
                e.edit(a, b, c, d, g)
            }))
                return this;
            var f = this._crudArgs(b, c, d, g);
            this._edit(a, "main");
            this._assembleMain();
            this._formOptions(f.opts);
            f.maybeOpen();
            return this
        };
        e.prototype.enable = function(a) {
            var b = this.s.fields;
            d.isArray(a) || (a = [a]);
            d.each(a, function(a, d) {
                b[d].enable()
            });
            return this
        };
        e.prototype.error = function(a, b) {
            b === j ? this._message(this.dom.formError, a) : this.s.fields[a].error(b);
            return this
        };
        e.prototype.field = function(a) {
            return this.s.fields[a]
        };
        e.prototype.fields = function() {
            return d.map(this.s.fields,
                    function(a, b) {
                        return b
                    })
        };
        e.prototype.get = function(a) {
            var b = this.s.fields;
            a || (a = this.fields());
            if (d.isArray(a)) {
                var c = {};
                d.each(a, function(a, d) {
                    c[d] = b[d].get()
                });
                return c
            }
            return b[a].get()
        };
        e.prototype.hide = function(a, b) {
            a ? d.isArray(a) || (a = [a]) : a = this.fields();
            var c = this.s.fields;
            d.each(a, function(a, d) {
                c[d].hide(b)
            });
            return this
        };
        e.prototype.inline = function(a, b, c) {
            var i = this;
            d.isPlainObject(b) && (c = b, b = j);
            var c = d.extend({}, this.s.formOptions.inline, c), g = this._dataSource("individual", a, b, this.s.fields),
                    e = d(g.node), f = g.field;
            if (d("div.DTE_Field", e).length || this._tidy(function() {
                i.inline(a, b, c)
            }))
                return this;
            this._edit(g.edit, "inline");
            var l = this._formOptions(c);
            if (!this._preopen("inline"))
                return this;
            var p = e.contents().detach();
            e.append(d('<div class="DTE DTE_Inline"><div class="DTE_Inline_Field"/><div class="DTE_Inline_Buttons"/></div>'));
            e.find("div.DTE_Inline_Field").append(f.node());
            c.buttons && e.find("div.DTE_Inline_Buttons").append(this.dom.buttons);
            this._closeReg(function(a) {
                d(q).off("click" +
                        l);
                if (!a) {
                    e.contents().detach();
                    e.append(p)
                }
                i._clearDynamicInfo()
            });
            setTimeout(function() {
                d(q).on("click" + l, function(a) {
                    var b = d.fn.addBack ? "addBack" : "andSelf";
                    !f._typeFn("owns", a.target) && d.inArray(e[0], d(a.target).parents()[b]()) === -1 && i.blur()
                })
            }, 0);
            this._focus([f], c.focus);
            this._postopen("inline");
            return this
        };
        e.prototype.message = function(a, b) {
            b === j ? this._message(this.dom.formInfo, a) : this.s.fields[a].message(b);
            return this
        };
        e.prototype.mode = function() {
            return this.s.action
        };
        e.prototype.modifier =
                function() {
                    return this.s.modifier
                };
        e.prototype.node = function(a) {
            var b = this.s.fields;
            a || (a = this.order());
            return d.isArray(a) ? d.map(a, function(a) {
                return b[a].node()
            }) : b[a].node()
        };
        e.prototype.off = function(a, b) {
            d(this).off(this._eventName(a), b);
            return this
        };
        e.prototype.on = function(a, b) {
            d(this).on(this._eventName(a), b);
            return this
        };
        e.prototype.one = function(a, b) {
            d(this).one(this._eventName(a), b);
            return this
        };
        e.prototype.open = function() {
            var a = this;
            this._displayReorder();
            this._closeReg(function() {
                a.s.displayController.close(a,
                        function() {
                            a._clearDynamicInfo()
                        })
            });
            if (!this._preopen("main"))
                return this;
            this.s.displayController.open(this, this.dom.wrapper);
            this._focus(d.map(this.s.order, function(b) {
                return a.s.fields[b]
            }), this.s.editOpts.focus);
            this._postopen("main");
            return this
        };
        e.prototype.order = function(a) {
            if (!a)
                return this.s.order;
            arguments.length && !d.isArray(a) && (a = Array.prototype.slice.call(arguments));
            if (this.s.order.slice().sort().join("-") !== a.slice().sort().join("-"))
                throw"All fields, and no additional fields, must be provided for ordering.";
            d.extend(this.s.order, a);
            this._displayReorder();
            return this
        };
        e.prototype.remove = function(a, b, c, e, g) {
            var f = this;
            if (this._tidy(function() {
                f.remove(a, b, c, e, g)
            }))
                return this;
            a.length === j && (a = [a]);
            var w = this._crudArgs(b, c, e, g);
            this.s.action = "remove";
            this.s.modifier = a;
            this.dom.form.style.display = "none";
            this._actionClass();
            this._event("initRemove", [this._dataSource("node", a), this._dataSource("get", a, this.s.fields), a]);
            this._assembleMain();
            this._formOptions(w.opts);
            w.maybeOpen();
            w = this.s.editOpts;
            null !==
                    w.focus && d("button", this.dom.buttons).eq(w.focus).focus();
            return this
        };
        e.prototype.set = function(a, b) {
            var c = this.s.fields;
            if (!d.isPlainObject(a)) {
                var e = {};
                e[a] = b;
                a = e
            }
            d.each(a, function(a, b) {
                c[a].set(b)
            });
            return this
        };
        e.prototype.show = function(a, b) {
            a ? d.isArray(a) || (a = [a]) : a = this.fields();
            var c = this.s.fields;
            d.each(a, function(a, d) {
                c[d].show(b)
            });
            return this
        };
        e.prototype.submit = function(a, b, c, e) {
            var g = this, f = this.s.fields, j = [], l = 0, p = !1;
            if (this.s.processing || !this.s.action)
                return this;
            this._processing(!0);
            var h = function() {
                j.length !== l || p || (p = !0, g._submit(a, b, c, e))
            };
            this.error();
            d.each(f, function(a, b) {
                b.inError() && j.push(a)
            });
            d.each(j, function(a, b) {
                f[b].error("", function() {
                    l++;
                    h()
                })
            });
            h();
            return this
        };
        e.prototype.title = function(a) {
            var b = d(this.dom.header).children("div." + this.classes.header.content);
            if (a === j)
                return b.html();
            b.html(a);
            return this
        };
        e.prototype.val = function(a, b) {
            return b === j ? this.get(a) : this.set(a, b)
        };
        var m = u.Api.register;
        m("editor()", function() {
            return v(this)
        });
        m("row.create()", function(a) {
            var b =
                    v(this);
            b.create(y(b, a, "create"))
        });
        m("row().edit()", function(a) {
            var b = v(this);
            b.edit(this[0][0], y(b, a, "edit"))
        });
        m("row().delete()", function(a) {
            var b = v(this);
            b.remove(this[0][0], y(b, a, "remove", 1))
        });
        m("rows().delete()", function(a) {
            var b = v(this);
            b.remove(this[0], y(b, a, "remove", this[0].length))
        });
        m("cell().edit()", function(a) {
            v(this).inline(this[0][0], a)
        });
        m("cells().edit()", function(a) {
            v(this).bubble(this[0], a)
        });
        e.pairs = function(a, b, c) {
            var e, g, f, b = d.extend({label: "label", value: "value"}, b);
            if (d.isArray(a)) {
                e =
                        0;
                for (g = a.length; e < g; e++)
                    f = a[e], d.isPlainObject(f) ? c(f[b.value] === j ? f[b.label] : f[b.value], f[b.label], e) : c(f, f, e)
            } else
                e = 0, d.each(a, function(a, b) {
                    c(b, a, e);
                    e++
                })
        };
        e.safeId = function(a) {
            return a.replace(".", "-")
        };
        e.prototype._constructor = function(a) {
            a = d.extend(!0, {}, e.defaults, a);
            this.s = d.extend(!0, {}, e.models.settings, {table: a.domTable || a.table, dbTable: a.dbTable || null, ajaxUrl: a.ajaxUrl, ajax: a.ajax, idSrc: a.idSrc, dataSource: a.domTable || a.table ? e.dataSources.dataTable : e.dataSources.html, formOptions: a.formOptions});
            this.classes = d.extend(!0, {}, e.classes);
            this.i18n = a.i18n;
            var b = this, c = this.classes;
            this.dom = {wrapper: d('<div class="' + c.wrapper + '"><div data-dte-e="processing" class="' + c.processing.indicator + '"></div><div data-dte-e="body" class="' + c.body.wrapper + '"><div data-dte-e="body_content" class="' + c.body.content + '"/></div><div data-dte-e="foot" class="' + c.footer.wrapper + '"><div class="' + c.footer.content + '"/></div></div>')[0], form: d('<form data-dte-e="form" class="' + c.form.tag + '"><div data-dte-e="form_content" class="' +
                        c.form.content + '"/></form>')[0], formError: d('<div data-dte-e="form_error" class="' + c.form.error + '"/>')[0], formInfo: d('<div data-dte-e="form_info" class="' + c.form.info + '"/>')[0], header: d('<div data-dte-e="head" class="' + c.header.wrapper + '"><div class="' + c.header.content + '"/></div>')[0], buttons: d('<div data-dte-e="form_buttons" class="' + c.form.buttons + '"/>')[0]};
            if (d.fn.dataTable.TableTools) {
                var i = d.fn.dataTable.TableTools.BUTTONS, g = this.i18n;
                d.each(["create", "edit", "remove"], function(a, b) {
                    i["editor_" +
                    b].sButtonText = g[b].button
                })
            }
            d.each(a.events, function(a, c) {
                b.on(a, function() {
                    var a = Array.prototype.slice.call(arguments);
                    a.shift();
                    c.apply(b, a)
                })
            });
            var c = this.dom, f = c.wrapper;
            c.formContent = t("form_content", c.form)[0];
            c.footer = t("foot", f)[0];
            c.body = t("body", f)[0];
            c.bodyContent = t("body_content", f)[0];
            c.processing = t("processing", f)[0];
            a.fields && this.add(a.fields);
            d(q).one("init.dt.dte", function(a, c) {
                b.s.table && c.nTable === d(b.s.table).get(0) && (c._editor = b)
            }).on("xhr.dt", function(a, c, e) {
                b.s.table && c.nTable ===
                        d(b.s.table).get(0) && b._optionsUpdate(e)
            });
            this.s.displayController = e.display[a.display].init(this);
            this._event("initComplete", [])
        };
        e.prototype._actionClass = function() {
            var a = this.classes.actions, b = this.s.action, c = d(this.dom.wrapper);
            c.removeClass([a.create, a.edit, a.remove].join(" "));
            "create" === b ? c.addClass(a.create) : "edit" === b ? c.addClass(a.edit) : "remove" === b && c.addClass(a.remove)
        };
        e.prototype._ajax = function(a, b, c) {
            var e = {type: "POST", dataType: "json", data: null, success: b, error: c}, g;
            g = this.s.action;
            var f = this.s.ajax || this.s.ajaxUrl, j = "edit" === g || "remove" === g ? this._dataSource("id", this.s.modifier) : null;
            d.isArray(j) && (j = j.join(","));
            d.isPlainObject(f) && f[g] && (f = f[g]);
            if (d.isFunction(f)) {
                var l = null, e = null;
                if (this.s.ajaxUrl) {
                    var h = this.s.ajaxUrl;
                    h.create && (l = h[g]);
                    -1 !== l.indexOf(" ") && (g = l.split(" "), e = g[0], l = g[1]);
                    l = l.replace(/_id_/, j)
                }
                f(e, l, a, b, c)
            } else
                "string" === typeof f ? -1 !== f.indexOf(" ") ? (g = f.split(" "), e.type = g[0], e.url = g[1]) : e.url = f : e = d.extend({}, e, f || {}), e.url = e.url.replace(/_id_/, j), e.data &&
                        (b = d.isFunction(e.data) ? e.data(a) : e.data, a = d.isFunction(e.data) && b ? b : d.extend(!0, a, b)), e.data = a, d.ajax(e)
        };
        e.prototype._assembleMain = function() {
            var a = this.dom;
            d(a.wrapper).prepend(a.header);
            d(a.footer).append(a.formError).append(a.buttons);
            d(a.bodyContent).append(a.formInfo).append(a.form)
        };
        e.prototype._blur = function() {
            var a = this.s.editOpts;
            a.blurOnBackground && !1 !== this._event("preBlur") && (a.submitOnBlur ? this.submit() : this._close())
        };
        e.prototype._clearDynamicInfo = function() {
            var a = this.classes.field.error,
                    b = this.s.fields;
            d("div." + a, this.dom.wrapper).removeClass(a);
            d.each(b, function(a, b) {
                b.error("").message("")
            });
            this.error("").message("")
        };
        e.prototype._close = function(a) {
            !1 !== this._event("preClose") && (this.s.closeCb && (this.s.closeCb(a), this.s.closeCb = null), this.s.closeIcb && (this.s.closeIcb(), this.s.closeIcb = null), d("body").off("focus.editor-focus"), this.s.displayed = !1, this._event("close"))
        };
        e.prototype._closeReg = function(a) {
            this.s.closeCb = a
        };
        e.prototype._crudArgs = function(a, b, c, e) {
            var g = this, f, h, l;
            d.isPlainObject(a) || ("boolean" === typeof a ? (l = a, a = b) : (f = a, h = b, l = c, a = e));
            l === j && (l = !0);
            f && g.title(f);
            h && g.buttons(h);
            return{opts: d.extend({}, this.s.formOptions.main, a), maybeOpen: function() {
                    l && g.open()
                }}
        };
        e.prototype._dataSource = function(a) {
            var b = Array.prototype.slice.call(arguments);
            b.shift();
            var c = this.s.dataSource[a];
            if (c)
                return c.apply(this, b)
        };
        e.prototype._displayReorder = function(a) {
            var b = d(this.dom.formContent), c = this.s.fields, a = a || this.s.order;
            b.children().detach();
            d.each(a, function(a, d) {
                b.append(d instanceof
                        e.Field ? d.node() : c[d].node())
            })
        };
        e.prototype._edit = function(a, b) {
            var c = this.s.fields, e = this._dataSource("get", a, c);
            this.s.modifier = a;
            this.s.action = "edit";
            this.dom.form.style.display = "block";
            this._actionClass();
            d.each(c, function(a, b) {
                var c = b.valFromData(e);
                b.set(c !== j ? c : b.def())
            });
            this._event("initEdit", [this._dataSource("node", a), e, a, b])
        };
        e.prototype._event = function(a, b) {
            b || (b = []);
            if (d.isArray(a))
                for (var c = 0, e = a.length; c < e; c++)
                    this._event(a[c], b);
            else
                return c = d.Event(a), d(this).triggerHandler(c,
                        b), c.result
        };
        e.prototype._eventName = function(a) {
            for (var b = a.split(" "), c = 0, d = b.length; c < d; c++) {
                var a = b[c], e = a.match(/^on([A-Z])/);
                e && (a = e[1].toLowerCase() + a.substring(3));
                b[c] = a
            }
            return b.join(" ")
        };
        e.prototype._focus = function(a, b) {
            var c;
            "number" === typeof b ? c = a[b] : b && (c = 0 === b.indexOf("jq:") ? d("div.DTE " + b.replace(/^jq:/, "")) : this.s.fields[b]);
            (this.s.setFocus = c) && c.focus()
        };
        e.prototype._formOptions = function(a) {
            var b = this, c = x++, e = ".dteInline" + c;
            this.s.editOpts = a;
            this.s.editCount = c;
            "string" === typeof a.title &&
                    (this.title(a.title), a.title = !0);
            "string" === typeof a.message && (this.message(a.message), a.message = !0);
            "boolean" !== typeof a.buttons && (this.buttons(a.buttons), a.buttons = !0);
            d(q).on("keydown" + e, function(c) {
                var e = d(q.activeElement), f = e.length ? e[0].nodeName.toLowerCase() : null, i = d(e).attr("type"), f = f === "input" && d.inArray(i, ["color", "date", "datetime", "datetime-local", "email", "month", "number", "password", "range", "search", "tel", "text", "time", "url", "week"]) !== -1;
                if (b.s.displayed && a.submitOnReturn && c.keyCode ===
                        13 && f) {
                    c.preventDefault();
                    b.submit()
                } else if (c.keyCode === 27) {
                    c.preventDefault();
                    switch (a.onEsc) {
                        case "blur":
                            b.blur();
                            break;
                        case "close":
                            b.close();
                            break;
                        case "submit":
                            b.submit()
                        }
                } else
                    e.parents(".DTE_Form_Buttons").length && (c.keyCode === 37 ? e.prev("button").focus() : c.keyCode === 39 && e.next("button").focus())
            });
            this.s.closeIcb = function() {
                d(q).off("keydown" + e)
            };
            return e
        };
        e.prototype._optionsUpdate = function(a) {
            var b = this;
            a.options && d.each(this.s.fields, function(c) {
                a.options[c] !== j && b.field(c).update(a.options[c])
            })
        };
        e.prototype._message = function(a, b) {
            !b && this.s.displayed ? d(a).fadeOut() : b ? this.s.displayed ? d(a).html(b).fadeIn() : (d(a).html(b), a.style.display = "block") : a.style.display = "none"
        };
        e.prototype._postopen = function(a) {
            var b = this;
            d(this.dom.form).off("submit.editor-internal").on("submit.editor-internal", function(a) {
                a.preventDefault()
            });
            if ("main" === a || "bubble" === a)
                d("body").on("focus.editor-focus", function() {
                    0 === d(q.activeElement).parents(".DTE").length && 0 === d(q.activeElement).parents(".DTED").length && b.s.setFocus &&
                            b.s.setFocus.focus()
                });
            this._event("open", [a]);
            return!0
        };
        e.prototype._preopen = function(a) {
            if (!1 === this._event("preOpen", [a]))
                return!1;
            this.s.displayed = a;
            return!0
        };
        e.prototype._processing = function(a) {
            var b = d(this.dom.wrapper), c = this.dom.processing.style, e = this.classes.processing.active;
            a ? (c.display = "block", b.addClass(e), d("div.DTE").addClass(e)) : (c.display = "none", b.removeClass(e), d("div.DTE").removeClass(e));
            this.s.processing = a;
            this._event("processing", [a])
        };
        e.prototype._submit = function(a, b, c, e) {
            var g =
                    this, f = u.ext.oApi._fnSetObjectDataFn, h = {}, l = this.s.fields, k = this.s.action, m = this.s.editCount, o = this.s.modifier, n = {action: this.s.action, data: {}};
            this.s.dbTable && (n.table = this.s.dbTable);
            if ("create" === k || "edit" === k)
                d.each(l, function(a, b) {
                    f(b.name())(n.data, b.get())
                }), d.extend(!0, h, n.data);
            if ("edit" === k || "remove" === k)
                n.id = this._dataSource("id", o), "edit" === k && d.isArray(n.id) && (n.id = n.id[0]);
            c && c(n);
            !1 === this._event("preSubmit", [n, k]) ? this._processing(!1) : this._ajax(n, function(c) {
                var s;
                g._event("postSubmit",
                        [c, n, k]);
                if (!c.error)
                    c.error = "";
                if (!c.fieldErrors)
                    c.fieldErrors = [];
                if (c.error || c.fieldErrors.length) {
                    g.error(c.error);
                    d.each(c.fieldErrors, function(a, b) {
                        var c = l[b.name];
                        c.error(b.status || "Error");
                        if (a === 0) {
                            d(g.dom.bodyContent, g.s.wrapper).animate({scrollTop: d(c.node()).position().top}, 500);
                            c.focus()
                        }
                    });
                    b && b.call(g, c)
                } else {
                    s = c.row !== j ? c.row : h;
                    g._event("setData", [c, s, k]);
                    if (k === "create") {
                        g.s.idSrc === null && c.id ? s.DT_RowId = c.id : c.id && f(g.s.idSrc)(s, c.id);
                        g._event("preCreate", [c, s]);
                        g._dataSource("create",
                                l, s);
                        g._event(["create", "postCreate"], [c, s])
                    } else if (k === "edit") {
                        g._event("preEdit", [c, s]);
                        g._dataSource("edit", o, l, s);
                        g._event(["edit", "postEdit"], [c, s])
                    } else if (k === "remove") {
                        g._event("preRemove", [c]);
                        g._dataSource("remove", o, l);
                        g._event(["remove", "postRemove"], [c])
                    }
                    if (m === g.s.editCount) {
                        g.s.action = null;
                        g.s.editOpts.closeOnComplete && (e === j || e) && g._close(true)
                    }
                    a && a.call(g, c);
                    g._event("submitSuccess", [c, s])
                }
                g._processing(false);
                g._event("submitComplete", [c, s])
            }, function(a, c, d) {
                g._event("postSubmit",
                        [a, c, d, n]);
                g.error(g.i18n.error.system);
                g._processing(false);
                b && b.call(g, a, c, d);
                g._event(["submitError", "submitComplete"], [a, c, d, n])
            })
        };
        e.prototype._tidy = function(a) {
            if (this.s.processing)
                return this.one("submitComplete", a), !0;
            if (d("div.DTE_Inline").length || "inline" === this.display()) {
                var b = this;
                this.one("close", function() {
                    if (b.s.processing)
                        b.one("submitComplete", function() {
                            var c = new d.fn.dataTable.Api(b.s.table);
                            if (b.s.table && c.settings()[0].oFeatures.bServerSide)
                                c.one("draw", a);
                            else
                                a()
                        });
                    else
                        a()
                }).blur();
                return!0
            }
            return!1
        };
        e.defaults = {table: null, ajaxUrl: null, fields: [], display: "lightbox", ajax: null, idSrc: null, events: {}, i18n: {create: {button: "New", title: "Create new entry", submit: "Create"}, edit: {button: "Edit", title: "Edit entry", submit: "Update"}, remove: {button: "Delete", title: "Delete", submit: "Delete", confirm: {_: "Are you sure you wish to delete %d rows?", 1: "Are you sure you wish to delete 1 row?"}}, error: {system: 'A system error has occurred (<a target="_blank" href="//datatables.net/tn/12">More information</a>).'}},
            formOptions: {bubble: d.extend({}, e.models.formOptions, {title: !1, message: !1, buttons: "_basic"}), inline: d.extend({}, e.models.formOptions, {buttons: !1}), main: d.extend({}, e.models.formOptions)}};
        var A = function(a, b, c) {
            d.each(b, function(b, d) {
                z(a, d.dataSrc()).each(function() {
                    for (; this.childNodes.length; )
                        this.removeChild(this.firstChild)
                }).html(d.valFromData(c))
            })
        }, z = function(a, b) {
            var c = a ? d('[data-editor-id="' + a + '"]').find('[data-editor-field="' + b + '"]') : [];
            return c.length ? c : d('[data-editor-field="' + b + '"]')
        },
                m = e.dataSources = {}, B = function(a) {
            a = d(a);
            setTimeout(function() {
                a.addClass("highlight");
                setTimeout(function() {
                    a.addClass("noHighlight").removeClass("highlight");
                    setTimeout(function() {
                        a.removeClass("noHighlight")
                    }, 550)
                }, 500)
            }, 20)
        }, C = function(a, b, c) {
            if (b && b.length !== j && "function" !== typeof b)
                return d.map(b, function(b) {
                    return C(a, b, c)
                });
            b = d(a).DataTable().row(b);
            if (null === c) {
                var e = b.data();
                return e.DT_RowId !== j ? e.DT_RowId : b.node().id
            }
            return u.ext.oApi._fnGetObjectDataFn(c)(b.data())
        };
        m.dataTable = {id: function(a) {
                return C(this.s.table,
                        a, this.s.idSrc)
            }, get: function(a) {
                var b = d(this.s.table).DataTable().rows(a).data().toArray();
                return d.isArray(a) ? b : b[0]
            }, node: function(a) {
                var b = d(this.s.table).DataTable().rows(a).nodes().toArray();
                return d.isArray(a) ? b : b[0]
            }, individual: function(a, b, c) {
                var e = d(this.s.table).DataTable(), f, h;
                d(a).hasClass("dtr-data") ? h = e.responsive.index(d(a).closest("li")) : (a = e.cell(a), h = a.index(), a = a.node());
                if (c) {
                    if (b)
                        f = c[b];
                    else {
                        var b = e.settings()[0].aoColumns[h.column], k = b.editField !== j ? b.editField : b.mData;
                        d.each(c,
                                function(a, b) {
                                    b.dataSrc() === k && (f = b)
                                })
                    }
                    if (!f)
                        throw"Unable to automatically determine field from source. Please specify the field name";
                }
                return{node: a, edit: h.row, field: f}
            }, create: function(a, b) {
                var c = d(this.s.table).DataTable();
                if (c.settings()[0].oFeatures.bServerSide)
                    c.draw();
                else if (null !== b) {
                    var e = c.row.add(b);
                    c.draw();
                    B(e.node())
                }
            }, edit: function(a, b, c) {
                b = d(this.s.table).DataTable();
                b.settings()[0].oFeatures.bServerSide ? b.draw(!1) : (a = b.row(a), null === c ? a.remove().draw(!1) : (a.data(c).draw(!1), B(a.node())))
            },
            remove: function(a) {
                var b = d(this.s.table).DataTable();
                b.settings()[0].oFeatures.bServerSide ? b.draw() : b.rows(a).remove().draw()
            }};
        m.html = {id: function(a) {
                return a
            }, initField: function(a) {
                var b = d('[data-editor-label="' + (a.data || a.name) + '"]');
                !a.label && b.length && (a.label = b.html())
            }, get: function(a, b) {
                var c = {};
                d.each(b, function(b, d) {
                    var e = z(a, d.dataSrc()).html();
                    d.valToData(c, null === e ? j : e)
                });
                return c
            }, node: function() {
                return q
            }, individual: function(a, b, c) {
                var e, f;
                "string" == typeof a && null === b ? (b = a, e = z(null,
                        b)[0], f = null) : "string" == typeof a ? (e = z(a, b)[0], f = a) : (b = b || d(a).attr("data-editor-field"), f = d(a).parents("[data-editor-id]").data("editor-id"), e = a);
                return{node: e, edit: f, field: c ? c[b] : null}
            }, create: function(a, b) {
                b && d('[data-editor-id="' + b[this.s.idSrc] + '"]').length && A(b[this.s.idSrc], a, b)
            }, edit: function(a, b, c) {
                A(a, b, c)
            }, remove: function(a) {
                d('[data-editor-id="' + a + '"]').remove()
            }};
        m.js = {id: function(a) {
                return a
            }, get: function(a, b) {
                var c = {};
                d.each(b, function(a, b) {
                    b.valToData(c, b.val())
                });
                return c
            }, node: function() {
                return q
            }};
        e.classes = {wrapper: "DTE", processing: {indicator: "DTE_Processing_Indicator", active: "DTE_Processing"}, header: {wrapper: "DTE_Header", content: "DTE_Header_Content"}, body: {wrapper: "DTE_Body", content: "DTE_Body_Content"}, footer: {wrapper: "DTE_Footer", content: "DTE_Footer_Content"}, form: {wrapper: "DTE_Form", content: "DTE_Form_Content", tag: "", info: "DTE_Form_Info", error: "DTE_Form_Error", buttons: "DTE_Form_Buttons", button: "btn"}, field: {wrapper: "DTE_Field", typePrefix: "DTE_Field_Type_", namePrefix: "DTE_Field_Name_", label: "DTE_Label",
                input: "DTE_Field_Input", error: "DTE_Field_StateError", "msg-label": "DTE_Label_Info", "msg-error": "DTE_Field_Error", "msg-message": "DTE_Field_Message", "msg-info": "DTE_Field_Info"}, actions: {create: "DTE_Action_Create", edit: "DTE_Action_Edit", remove: "DTE_Action_Remove"}, bubble: {wrapper: "DTE DTE_Bubble", liner: "DTE_Bubble_Liner", table: "DTE_Bubble_Table", close: "DTE_Bubble_Close", pointer: "DTE_Bubble_Triangle", bg: "DTE_Bubble_Background"}};
        d.fn.dataTable.TableTools && (m = d.fn.dataTable.TableTools.BUTTONS, m.editor_create =
                d.extend(!0, m.text, {sButtonText: null, editor: null, formTitle: null, formButtons: [{label: null, fn: function() {
                                this.submit()
                            }}], fnClick: function(a, b) {
                        var c = b.editor, d = c.i18n.create, e = b.formButtons;
                        if (!e[0].label)
                            e[0].label = d.submit;
                        c.create({title: d.title, buttons: e})
                    }}), m.editor_edit = d.extend(!0, m.select_single, {sButtonText: null, editor: null, formTitle: null, formButtons: [{label: null, fn: function() {
                        this.submit()
                    }}], fnClick: function(a, b) {
                var c = this.fnGetSelectedIndexes();
                if (c.length === 1) {
                    var d = b.editor, e = d.i18n.edit,
                            f = b.formButtons;
                    if (!f[0].label)
                        f[0].label = e.submit;
                    d.edit(c[0], {title: e.title, buttons: f})
                }
            }}), m.editor_remove = d.extend(!0, m.select, {sButtonText: null, editor: null, formTitle: null, formButtons: [{label: null, fn: function() {
                        var a = this;
                        this.submit(function() {
                            d.fn.dataTable.TableTools.fnGetInstance(d(a.s.table).DataTable().table().node()).fnSelectNone()
                        })
                    }}], question: null, fnClick: function(a, b) {
                var c = this.fnGetSelectedIndexes();
                if (c.length !== 0) {
                    var d = b.editor, e = d.i18n.remove, f = b.formButtons, h = e.confirm === "string" ?
                            e.confirm : e.confirm[c.length] ? e.confirm[c.length] : e.confirm._;
                    if (!f[0].label)
                        f[0].label = e.submit;
                    d.remove(c, {message: h.replace(/%d/g, c.length), title: e.title, buttons: f})
                }
            }}));
        e.fieldTypes = {};
        var n = e.fieldTypes, m = d.extend(!0, {}, e.models.fieldType, {get: function(a) {
                return a._input.val()
            }, set: function(a, b) {
                a._input.val(b).trigger("change")
            }, enable: function(a) {
                a._input.prop("disabled", false)
            }, disable: function(a) {
                a._input.prop("disabled", true)
            }});
        n.hidden = d.extend(!0, {}, m, {create: function(a) {
                a._val = a.value;
                return null
            }, get: function(a) {
                return a._val
            }, set: function(a, b) {
                a._val = b
            }});
        n.readonly = d.extend(!0, {}, m, {create: function(a) {
                a._input = d("<input/>").attr(d.extend({id: e.safeId(a.id), type: "text", readonly: "readonly"}, a.attr || {}));
                return a._input[0]
            }});
        n.text = d.extend(!0, {}, m, {create: function(a) {
                a._input = d("<input/>").attr(d.extend({id: e.safeId(a.id), type: "text"}, a.attr || {}));
                return a._input[0]
            }});
        n.password = d.extend(!0, {}, m, {create: function(a) {
                a._input = d("<input/>").attr(d.extend({id: e.safeId(a.id), type: "password"},
                a.attr || {}));
                return a._input[0]
            }});
        n.textarea = d.extend(!0, {}, m, {create: function(a) {
                a._input = d("<textarea/>").attr(d.extend({id: e.safeId(a.id)}, a.attr || {}));
                return a._input[0]
            }});
        n.select = d.extend(!0, {}, m, {_addOptions: function(a, b) {
                var c = a._input[0].options;
                c.length = 0;
                b && e.pairs(b, a.optionsPair, function(a, b, d) {
                    c[d] = new Option(b, a)
                })
            }, create: function(a) {
                a._input = d("<select/>").attr(d.extend({id: e.safeId(a.id)}, a.attr || {}));
                n.select._addOptions(a, a.options || a.ipOpts);
                return a._input[0]
            }, update: function(a,
                    b) {
                var c = d(a._input), e = c.val();
                n.select._addOptions(a, b);
                c.children('[value="' + e + '"]').length && c.val(e)
            }});
        n.checkbox = d.extend(!0, {}, m, {_addOptions: function(a, b) {
                var c = a._input.empty();
                b && e.pairs(b, a.optionsPair, function(b, d, f) {
                    c.append('<div><input id="' + e.safeId(a.id) + "_" + f + '" type="checkbox" value="' + b + '" /><label for="' + e.safeId(a.id) + "_" + f + '">' + d + "</label></div>")
                })
            }, create: function(a) {
                a._input = d("<div />");
                n.checkbox._addOptions(a, a.options || a.ipOpts);
                return a._input[0]
            }, get: function(a) {
                var b =
                [];
                a._input.find("input:checked").each(function() {
                    b.push(this.value)
                });
                return a.separator ? b.join(a.separator) : b
            }, set: function(a, b) {
                var c = a._input.find("input");
                !d.isArray(b) && typeof b === "string" ? b = b.split(a.separator || "|") : d.isArray(b) || (b = [b]);
                var e, f = b.length, h;
                c.each(function() {
                    h = false;
                    for (e = 0; e < f; e++)
                        if (this.value == b[e]) {
                            h = true;
                            break
                        }
                    this.checked = h
                }).change()
            }, enable: function(a) {
                a._input.find("input").prop("disabled", false)
            }, disable: function(a) {
                a._input.find("input").prop("disabled", true)
            }, update: function(a,
                    b) {
                var c = n.checkbox, d = c.get(a);
                c._addOptions(a, b);
                c.set(a, d)
            }});
        n.radio = d.extend(!0, {}, m, {_addOptions: function(a, b) {
                var c = a._input.empty();
                b && e.pairs(b, a.optionsPair, function(b, f, h) {
                    c.append('<div><input id="' + e.safeId(a.id) + "_" + h + '" type="radio" name="' + a.name + '" /><label for="' + e.safeId(a.id) + "_" + h + '">' + f + "</label></div>");
                    d("input:last", c).attr("value", b)[0]._editor_val = b
                })
            }, create: function(a) {
                a._input = d("<div />");
                n.radio._addOptions(a, a.options || a.ipOpts);
                this.on("open", function() {
                    a._input.find("input").each(function() {
                        if (this._preChecked)
                            this.checked =
                            true
                    })
                });
                return a._input[0]
            }, get: function(a) {
                a = a._input.find("input:checked");
                return a.length ? a[0]._editor_val : j
            }, set: function(a, b) {
                a._input.find("input").each(function() {
                    this._preChecked = false;
                    if (this._editor_val == b)
                        this._preChecked = this.checked = true;
                    else
                        this._preChecked = this.checked = false
                });
                a._input.find("input:checked").change()
            }, enable: function(a) {
                a._input.find("input").prop("disabled", false)
            }, disable: function(a) {
                a._input.find("input").prop("disabled", true)
            }, update: function(a, b) {
                var c = n.radio,
                        d = c.get(a);
                c._addOptions(a, b);
                var e = a._input.find("input");
                c.set(a, e.filter('[value="' + d + '"]').length ? d : e.eq(0).attr("value"))
            }});
        n.date = d.extend(!0, {}, m, {create: function(a) {
                if (!d.datepicker) {
                    a._input = d("<input/>").attr(d.extend({id: e.safeId(a.id), type: "date"}, a.attr || {}));
                    return a._input[0]
                }
                a._input = d("<input />").attr(d.extend({type: "text", id: e.safeId(a.id), "class": "jqueryui"}, a.attr || {}));
                if (!a.dateFormat)
                    a.dateFormat = d.datepicker.RFC_2822;
                if (a.dateImage === j)
                    a.dateImage = "../../images/calender.png";
                setTimeout(function() {
                    d(a._input).datepicker(d.extend({showOn: "both", dateFormat: a.dateFormat, buttonImage: a.dateImage, buttonImageOnly: true}, a.opts));
                    d("#ui-datepicker-div").css("display", "none")
                }, 10);
                return a._input[0]
            }, set: function(a, b) {
                d.datepicker && a._input.hasClass("hasDatepicker") ? a._input.datepicker("setDate", b).change() : d(a._input).val(b)
            }, enable: function(a) {
                d.datepicker ? a._input.datepicker("enable") : d(a._input).prop("disabled", false)
            }, disable: function(a) {
                d.datepicker ? a._input.datepicker("disable") :
                        d(a._input).prop("disabled", true)
            }, owns: function(a, b) {
                return d(b).parents("div.ui-datepicker").length || d(b).parents("div.ui-datepicker-header").length ? true : false
            }});
        e.prototype.CLASS = "Editor";
        e.version = "1.4.2";
        return e
    };
    "function" === typeof define && define.amd ? define(["jquery", "datatables"], x) : "object" === typeof exports ? x(require("jquery"), require("datatables")) : jQuery && !jQuery.fn.dataTable.Editor && x(jQuery, jQuery.fn.dataTable)
})(window, document);
