<?php

//https://www.script-tutorials.com/pure-html5-file-upload/
require_once '../../config.php';
session_start();
$success = TRUE;
$message = '';
$errors = array();
$array_userid = array();
$csv_duplicate_check = array();
$array_level = array();

function bytesToSize1024($bytes, $precision = 2) {
    $unit = array('B', 'KB', 'MB');
    return @round($bytes / pow(1024, ($i = floor(log($bytes, 1024)))), $precision) . ' ' . $unit[$i];
}

function OlmUserOperationCall($data, $url) {
    $postvars = '';
    foreach ($data as $key => $value) {
        $postvars .= $key . "=" . $value . "&";
    }
    $postvars = rtrim($postvars, "&");
//    echo $url . "?" . $postvars;
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_POST, 1);                //0 for a get request
    curl_setopt($ch, CURLOPT_POSTFIELDS, $postvars);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 3);
    curl_setopt($ch, CURLOPT_TIMEOUT, 20);
    $response = curl_exec($ch);
//    echo $response;
    curl_close($ch);
}

$key = '1234567890123456';

function encrypt($data, $key) {
    return base64_encode(
            mcrypt_encrypt(
                    MCRYPT_RIJNDAEL_128, $key, $data, MCRYPT_MODE_CBC, "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
            )
    );
}

if (is_uploaded_file($_FILES['image_file']['tmp_name'])) {
    //echo "<h1>" . "Displaying content:" . "</h2>";
//    readfile($_FILES['image_file']['tmp_name']);
    if ($_FILES['image_file']['type'] !== "application/vnd.ms-excel") {
        echo '<div class="form-group has-error">';
        $msg = 'Only CSV file format allowed';
        echo "<p class='has-error help-block'>" . $msg . "</p>";
        echo '</div>';
        die();
    }
} else {
    echo '<div class="form-group has-error">';
    $msg = 'No file Selected'
            . '';
    echo "<p class='has-error help-block'>" . $msg . "</p>";
    echo '</div>';
    exit();
}

$handle = fopen($_FILES['image_file']['tmp_name'], "r");

$i = 0;
$data = '';
while (($data = fgetcsv($handle, 1000, ",")) !== FALSE) {
    if ($i > 0) {
        
        if ($data[0] == '') {
            $errors[] = "*Required: on line no." . $i . "<br>" .
                    'UserID field is required and must be unique';
            $success = false;
        } else if ($data[1] == '') {
            $errors[] = "*Required: on line no." . $i . "<br>" . 'pwd field is required';
            $success = false;
        } else if ($data[2] == '') {
            $errors[] = "*Required: on line no." . $i . "<br>" . 'First name field is required';
            $success = false;
        } else if ($data[3] == '') {
            $errors[] = "*Required: on line no." . $i . "<br>" . 'Last Name field is required';
            $success = FALSE;
        } else {
            $qury = "SELECT userid FROM people WHERE userid = '" . $data[0] . "'";
            $res1 = $link->query($qury);
            $num_rows = mysqli_num_rows($res1);
            if ($num_rows == 0) {

                $import = "INSERT INTO"
                        . " people(userid, password, firstname, surname, icon, schoolid, language, role) "
                        . "VALUES ('" . trim($data[0]) . "' , '" . trim(encrypt($data[1], $key)) . "' , '" . trim($data[2]) . "' , '" . trim($data[3]) . "' , '" . trim($data[4]) . "' , '" . trim($_SESSION['schoolid']) . "' , '" . trim($data[5]) . "' , '2')";
                mysqli_query($link, "SET firstname UTF8");
                $res = mysqli_query($link, $import) or die(mysqli_error($link));
                $lastInsertedID = mysqli_insert_id($link);

                if (isset($data[6]) && $data[6] != '') {
                    $qry = "INSERT INTO student_has_levels (studid,levelid) VALUES ('" . $lastInsertedID . "' , '" . $data[6] . "')";
                    $res = mysqli_query($link, $qry);
                }
                // to insert to extlink
                if (isset($data[8]) && $data[8] != '') {
                    if (isset($data[9]) && $data[9] != '') {

                        $qry = "INSERT INTO extlink (internalstdid,extid,datasourceid,schoolid) VALUES ('" . trim($lastInsertedID) . "', '" . trim($data[8]) . "', '" . trim($data[9]) . "', '" . $_SESSION['schoolid'] . "')";
                        $res = mysqli_query($link, $qry);
                    }
                }

                $query = "SELECT * FROM people WHERE id='" . $lastInsertedID . "'";
                $result = $link->query($query);
                $num_row = mysqli_num_rows($result);
                if ($num_row > 0) {
                    $row1 = mysqli_fetch_assoc($result);

                    $fields = array('sharedsecret' => 'l753Ea{sB[]o}x*',
                        'leasid' => $lastInsertedID,
                        'username' => $row1['userid'],
                        'forename' => $row1['firstname'],
                        'surname' => $row1['surname'],
                        'password' => $row1['password'],
                        'school' => $row1['schoolid'],
                        'type' => 'student',
                    );
                                        $url = "http://54.71.33.22/leas-olm/api/updateuser";

                    echo OlmUserOperationCall($fields, $url);
                } // end add competency to activity
                //add user / student to group 
                if (isset($data[7]) && $data[7] != '') {
                    // to associate student a single group 
                    $qry = "INSERT INTO group_has_students (studentid,groupid) VALUES ('" . $lastInsertedID . "', '" . trim($data[7]) . "')";
                    $res = mysqli_query($link, $qry);

                    $query = "SELECT * FROM group_has_students WHERE studentid='" . $lastInsertedID . "'";
                    $res_group = $link->query($query);
                    $numrow = mysqli_num_rows($res_group);
                                        $url_group = "http://54.71.33.22/leas-olm/api/masterapi";
                                        

                    if ($numrow > 0) {
                        $row2 = mysqli_fetch_assoc($res_group);
                        $data = array('sharedsecret' => 'l753Ea{sB[]o}x*',
                            'leasid' => $_SESSION['userid'],
                            'method' => 'addusertogroup',
                            'userid' => $lastInsertedID,
                            'groupid' => $row2['groupid'],
                        );
                        echo OlmUserOperationCall($data, $url_group);
                    }
                    // end add user to group
                }
                $message['success'] = "Data Inserted successfully";
                $message['fail'] = "Data Inserted but have below errors";
//                $success = TRUE;
            } else {
                $errors[] = "Duplication Error: on line no." . $i . "<br>" .
                        "UserID=>" . "&nbsp" . $data[0] . '.' . "&nbsp" . "&nbsp" . "user ID already exists *username must be unique*";
                $success = FALSE;
            }
        }
    }

    $i++;
}

if (!empty($message) && $success) {
    echo '<div class="form-group has-success">';
    echo "<p class='has-success help-block'>" . $message['success'] . "</p>";
    echo '</div>';
} elseif (!empty($message) && !$success) {
    echo '<div class="form-group has-success">';
    echo "<p class='has-success help-block'>" . $message['fail'] . "</p>";
    echo '</div>';
}

if (!$success && !empty($errors)) {
    foreach ($errors as $key => $value) {
        echo '<div class="form-group has-error">';
        echo "<p class='has-error help-block'>" . $value . "</p>";
        echo '</div>';
    }
}

fclose($handle);




