function initSkills(){
   //Add Classes
   //console.log("initClasses");
   $('#btn_add_skills').click(function(){
        $('#frm_add_skills')[0].reset();
        $('#frm_add_skills').clearForm();
        $('#progress .bar').css('width',0 + '%');
        //$("#frm_add_skills #class_icon_image").removeAttr('src');
        //$('#modal_add_skills #modal-header-edit').html("<b>Add a Class</b>");
    });

   $("a#btn_submit_add_skills").click(function(){
        var data = $('#frm_add_skills').serialize();
        $.ajax({
            type: "POST",
            url: "../webservice/public_html/index.php/skills",
            data: $('form#frm_add_skills').serialize(),
            success: function(msg){
                var obj = $.parseJSON(msg);
                var success = obj["success"];
                var content = obj["content"];
                if(success){
                    $('#modal_add_skills').modal('toggle');

                    if(localVars.skillsDataTable){
                        localVars.skillsDataTable.fnReloadAjax('../webservice/public_html/index.php/skills');
                    }
                }else {
                    alert(content);
                }
            },
            error: function(){
                alert("Error: Data could not be saved!");
            }
        });
   });
}
function initSkillsTable () {
    console.log("initSkillsTable");
	localVars.skillsDataTable = $('#tbl_skills').dataTable({
		"sDom": "<'row'<'span5'l><'span5'f>r>t<'row'<'span5'i><'span5'p>>",
		"sAjaxSource": '../webservice/public_html/index.php/skills',
		"aaSorting": [[ 0, "asc" ]],
        "sAjaxDataProp": "content",
        "sPaginationType": "full_numbers",
        "sRowSelect": "multi",
        "aoColumns": [
        	{
        		"mData": "id",
        		"sTitle": "ID",
        		"sName": "id",
        	},
            {
                "mData": "olmid",
                "sTitle": "OlmID",
                "sName": "olmid",
            },
        	{
        		"mData": "name",
        		"sTitle": "Name",
        		"sName": "name",
        	},
        	{
        		"mData": "description",
        		"sTitle": "Description",
        		"sName": "description",
        	},/*
            {
                "mData": "level",
                "sTitle": "Level",
                "sName": "level",
            },
            {
                "mData": "prerequisites",
                "sTitle": "Prerequisites",
                "sName": "prerequisites",
            },*/
            {
                "mData": "schoollevel",
                "sTitle": "Schoollevel",
                "sName": "schoollevel",
            },
            {
                "mData": "group",
                "sTitle": "Group",
                "sName": "group",
            },
            {
                "mData": "semester",
                "sTitle": "Semester",
                "sName": "semester",
            }
        ],
         "aoColumnDefs": 
        [
            { "bSearchable": false, "bVisible": false, "aTargets": [0] },
        ],
        "fnCreatedRow": function( nRow, aData, iDataIndex ) {
            $(nRow).attr('id', aData['id']);
        },
        "fnServerData": function ( sSource, aoData, fnCallback, oSettings ) {
            oSettings.jqXHR = $.ajax( {
                "dataType": 'json',
                "type": "GET",
                "url": sSource,
                "data": aoData,
                "success": function(json){
                    var items = {};
                    if(json["success"]){
                        $.each(json["content"], function(index, item) {
                            var id = item["id"];
                            items[id] = item;
                        });  
                    }

                    localVars.skills = items;
                    fnCallback(json);
                }
            } );
        }
	    } ).makeEditable({
	        sDeleteURL: "../webservice/public_html/index.php/delete_skills",
	        sDeleteRowButtonId: "btn_delete_skills",
	        
	        sUpdateURL: "../webservice/public_html/index.php/skills_property",
	        
	        //sAddURL: "../webservice/public_html/index.php/add_people",
	        //sAddNewRowFormId: "frm_add_people",
	        //sAddNewRowButtonId: "btn_add_people",
	        //sAddNewRowOkButtonId: "btn_add_people_ok",
	        //sAddNewRowCancelButtonId: "btn_add_people_cancel",
	        "aoColumns": [
	            {},
	            {},
                {},
                {},
                {},
                {}
	        ]
	    });
}