<?php

session_start();

if (!isset($_SESSION['uName'])) {
    header('Location:../../');
}
// DataTables PHP library
include( "../../php/DataTables.php" );

// Alias Editor classes so they are easy to use
use DataTables\Editor,
    DataTables\Editor\Field,
    DataTables\Editor\Format,
    DataTables\Editor\Join,
    DataTables\Editor\Upload,
    DataTables\Editor\Validate;

/*
 * Example PHP implementation used for the join.html example
 */
Editor::inst($db, 'datasource')
        ->field(
                Field::inst('datasource.id'),
                Field::inst('datasource.name')->validator('Validate::notEmpty'),
//                Field::inst('datasource.activityid'),
                Field::inst('datasource.token'),
                Field::inst('datasource.schoolid')
                ->setValue($_SESSION['schoolid'])
                
        )
        ->where('datasource.schoolid', $_SESSION['schoolid'])
        ->process($_POST)
        ->json();
