<?php

session_start();

if (!isset($_SESSION['uName'])) {
    header('Location:../../');
}

// DataTables PHP library
include( "../../php/DataTables.php" );

// Alias Editor classes so they are easy to use
use DataTables\Editor,
    DataTables\Editor\Field,
    DataTables\Editor\Format,
    DataTables\Editor\Join,
    DataTables\Editor\Upload,
    DataTables\Editor\Validate;

/*
 * Example PHP implementation used for the join.html example
 */
Editor::inst($db, 'settings')
        ->field(
                Field::inst('settings.termname')->validator('Validate::unique', array(
                    'required' => true,
                    'message' => 'This field is required and must be unique.')), 
                Field::inst('settings.year'), 
                Field::inst('settings.schoolid')
                ->setValue($_SESSION['schoolid'])
        )
        ->where('settings.schoolid', $_SESSION['schoolid'])
        ->process($_POST)
        ->json();
